module ActiveDirectory
  class Utils
    def self.microsoft_encode_password(pwd)
      ret = ""
      pwd = "\"" + pwd + "\""
      pwd.length.times{|i| ret+= "#{pwd[i..i]}\000" }
      ret
    end

    def self.ldap_18_date(datetime)
      if datetime && datetime.to_i != 9223372036854775807 && datetime.to_i != 0
        base = Date.new(1601, 1, 1)
        base += datetime.to_i / (60 * 10000000 * 1440)
        if base != 0
          base
        else
          false
        end
      else
        false
      end
    end

    def self.ldap_datetime(datetime)
      datetime.utc.strftime("%Y%m%d%H%M%S.0Z")
    end
  end
end
