require 'net/ldap'
require 'active_directory/errors'

module ActiveDirectory
  autoload :Configuration, 'active_directory/configuration'
  autoload :User, 'active_directory/user'
  autoload :Client, 'active_directory/client'
  autoload :Utils, 'active_directory/utils'
  autoload :DirectoryObject, 'active_directory/directory_object'
  autoload :Group, 'active_directory/group'

  def self.configure(&block)
    ActiveDirectory::Configuration.instance_eval(&block)
  end
end
